// throwit2.cs
// Throwing your own error.
//=============================================
using System;

class NegativeNumberException : Exception
{
  public NegativeNumberException()
  {
  }

  public NegativeNumberException( string e ) : base (e)
  {
  }

  public NegativeNumberException( string e, Exception inner ) :
          base ( e, inner )
  {
  }
}

class MyAppClass 
{
   public static void Main() 
   {
      int result;

      try
      {
          result = MyMath.SubtractEm( 10, 2 );
          Console.WriteLine( "Result of SubtractEm(10, 2) is {0}", result);

          result = MyMath.SubtractEm( 2, 10 );
          Console.WriteLine( "Result of SubractEm(2, 10) is {0}", result);
      }

      catch (NegativeNumberException msg)
      {
          Console.WriteLine("Sorry, you can't subtract to a result less than zero!");
          Console.WriteLine("\nPassed Error Message: \n{0}", msg);
      }

      catch (Exception e)
      {
         Console.WriteLine("Exception caught: {0}", e);
      }

      Console.WriteLine("At end of program");
   }
}

class MyMath
{
   static public int SubtractEm(int x, int y)
   {
      if( y > x )
         throw( new NegativeNumberException() );
     
      return( x - y );
   }
}
