// inherit02.cs
// Basic inheritance. 
//===============================================
using System;
using System.Text;

class Person
{
   protected string firstName = "\0";
   protected string middleName = "\0";
   protected string lastName = "\0";
   private int   age;

   //ToDo: Add properties to access data members

   public Person()
   {
   }

   public Person(string fn, string ln)
   {
      firstName = fn;
      lastName = ln;
   }

   public Person(string fn, string mn, string ln)
   {
      firstName = fn;
      middleName = mn;
      lastName = ln;
   }

   public Person(string fn, string mn, string ln, int a)
   {
      firstName = fn;
      middleName = mn;
      lastName = ln;
      age = a;
   }

   public void displayAge()
   {
      Console.WriteLine("Age {0}", age);
   }

   public void displayFullName()
   {
       StringBuilder FullName = new StringBuilder();
      
       FullName.Append(firstName);
       FullName.Append(" ");      
       if( middleName[0] != '\0' && middleName != null )
       {
          FullName.Append(middleName[0]);
          FullName.Append(". ");
       }
       FullName.Append(lastName);      

       Console.WriteLine(FullName);
   }   
}

class Employee : Person 
{
   private ushort hYear;

   public ushort hireYear
   {
     get { return(hYear); }
     set { hYear = value; }   
   }

   public Employee() : base()
   {
   }

   public Employee( string fn, string ln ) : base( fn, ln)
   {
   }

   public Employee(string fn, string mn, string ln, int a) : 
              base(fn, mn, ln, a)
   {
   }

   public Employee(string fn, string ln, ushort hy) : base(fn, ln)
   {
      hireYear = hy;
   }

   public new void displayFullName()
   {
      Console.Write("Employee: ");
      base.displayFullName();
   }   
}

class NameApp 
{
   public static void Main() 
   {
       Person myWife = new Person("Melissa", "Anne", "Jones", 21);
       Employee me = new Employee("Bradley", "L.", "Jones", 23);
       Employee you = new Employee("Kyle", "Rinni", 2000);

       myWife.displayFullName();
       myWife.displayAge();

       me.displayFullName();
       Console.WriteLine("Year hired: {0}", me.hireYear);
       me.displayAge();
      
       you.displayFullName();
       Console.WriteLine("Year hired of him: {0}", you.hireYear);
       you.displayAge();
   }
}
