//  multi.cs - 
//--------------------------------------------------------------------

using System;

public interface IShape
{
   // Cut out other methods to simplify example.
   double Area();
   int Sides { get; }
}

public interface IShapeDisplay
{
   void Display();
}

public class Square : IShape, IShapeDisplay
{
   private int sides; 
   public  int SideLength;

   public int Sides 
   {
      get { return sides; }
   }

   public double Area()  
   {
      return ((double) (SideLength * SideLength));
   }

   public double Circumference()
   {
      return ((double) (Sides * SideLength));
   }

   public Square()
   {
      sides = 4;
   }

   public void Display()
   {
      Console.WriteLine("\nDisplaying Square information:");
      Console.WriteLine("Side length: {0}", this.SideLength);
      Console.WriteLine("Sides: {0}", this.Sides);
      Console.WriteLine("Area: {0}", this.Area());
   }
}

public class myApp
{
   public static void Main()
   {
      Square mySquare = new Square();
      mySquare.SideLength = 7;

      mySquare.Display();
   }
}
