//  Ex1405.cs -
//  This adds the exception handler for the ToUpperVowels. It also
//  changes the Main logic to use the Console.Read method to allow
//  you to enter text that will be checked against the event handler
//  Pressing enter, processes the current line of text. Press Ctrl+Z
//  To get out of the loop.
//-----------------------------------------------------------------

using System;

delegate void CharEventHandler(object source, CharEventArgs e);

public class CharEventArgs : EventArgs
{
    public char CurrChar;
    public CharEventArgs(char CurrChar)
    {  
       this.CurrChar = CurrChar;
    }
}

class CharChecker
{
   char curr_char;
   public event CharEventHandler TestChar;
   public char Curr_Char
   {
      get { return curr_char; }
      set
      {
         if (TestChar != null )
         {
             CharEventArgs args = new CharEventArgs(value);
             TestChar(this, args);
             curr_char = args.CurrChar;
         }   
      }
   }
}

class MyApp
{
   static void Main()
   {
      CharChecker tester = new CharChecker();

      tester.TestChar += new CharEventHandler(Drop_A);
      tester.TestChar += new CharEventHandler(Change_D);
      tester.TestChar += new CharEventHandler(ToUpperVowels);
     
      Console.WriteLine("Enter Text or press <ctrl>+Z to end...");

      int val;
      while ( true )
      {
          val = Console.Read();
          if ( val == - 1 ) break;
          tester.Curr_Char = (char) val;
          Console.WriteLine( "Echo: {0}", tester.Curr_Char );
      }
      Console.WriteLine( "\nDone" );
   }

   static void Drop_A(object source, CharEventArgs e)
   {
      if(e.CurrChar == 'a' || e.CurrChar == 'A' )
      {
         Console.WriteLine("Don't like 'a'!");
         e.CurrChar = 'X';
      }
   }

   static void Change_D(object source, CharEventArgs e)
   {
      if(e.CurrChar == 'd' || e.CurrChar == 'D' )
      {
         Console.WriteLine("D's are good!");
         e.CurrChar = 'Z';
      }
   }

   static void ToUpperVowels(object source, CharEventArgs e)
   {
      switch( e.CurrChar )
      {
         case 'a':   e.CurrChar = 'A';
                     break;
         case 'e':   e.CurrChar = 'E';
                     break;
         case 'i':   e.CurrChar = 'I';
                     break;
         case 'o':   e.CurrChar = 'O';
                     break;
         case 'u':   e.CurrChar = 'U';
                     break;
      }
   }
}
