//  events.cs - Using events
//-----------------------------------------------------------------

using System;

delegate void CharEventHandler(object source, CharEventArgs e);

public class CharEventArgs : EventArgs
{
    public char CurrChar;
    public CharEventArgs(char CurrChar)
    {  
       this.CurrChar = CurrChar;
    }
}

class CharChecker
{
   char curr_char;
   public event CharEventHandler TestChar;
   public char Curr_Char
   {
      get { return curr_char; }
      set
      {
         if (TestChar != null )
         {
             CharEventArgs args = new CharEventArgs(value);
             TestChar(this, args);
             curr_char = args.CurrChar;
         }   
      }
   }
}

class myApp
{
   static void Main()
   {
      CharChecker tester = new CharChecker();

      tester.TestChar += new CharEventHandler(Drop_A);

      tester.Curr_Char = 'B';
      Console.WriteLine("{0}", tester.Curr_Char);

      tester.Curr_Char = 'r';
      Console.WriteLine("{0}", tester.Curr_Char);

      tester.Curr_Char = 'a';
      Console.WriteLine("{0}", tester.Curr_Char);

      tester.Curr_Char = 'd';
      Console.WriteLine("{0}", tester.Curr_Char);

   }

   static void Drop_A(object source, CharEventArgs e)
   {
      if(e.CurrChar == 'a' || e.CurrChar == 'A' )
      {
         Console.WriteLine("Don't like 'a'!");
         e.CurrChar = 'X';
      }
   }
}
