// Ex1603.cs - 
//--------------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;


public class frmGetNumber : Form
{


   private Button btnOK;
   private Label  lblPrompt;
   private Label  lblResponse;
   private TextBox txtNbr;

   public frmGetNumber()
   {
      InitializeComponent();
   }    

   private void InitializeComponent()
   {
       this.FormBorderStyle = FormBorderStyle.Fixed3D;
       this.Text = "One To Ten";
       this.StartPosition = FormStartPosition.CenterScreen;

       // Instantiate the controls...
       lblPrompt   = new Label();
       lblResponse = new Label();

       txtNbr = new TextBox();
       btnOK  = new Button();   

       // Set properties

       lblPrompt.AutoSize = true;
       lblPrompt.Text     = "Enter a Number:";
       lblPrompt.Location = new Point( 20, 20);

       txtNbr.Width = 50;
       txtNbr.Location = new Point(140, 20);


       lblResponse.Width = 250;
       lblResponse.Height = 20;
       lblResponse.Text = "Enter a number from 0 to 1000.";
       lblResponse.TextAlign = ContentAlignment.MiddleCenter;
       lblResponse.Location = 
           new Point(((this.Width/2) - (lblResponse.Width / 2 )), 140);

       this.Controls.Add(lblPrompt);    // Add label to form
       this.Controls.Add(lblResponse);   
       this.Controls.Add(txtNbr);

       btnOK.Text = "Done";
       btnOK.BackColor = Color.LightGray;
       btnOK.Location = new Point(((this.Width/2) - (btnOK.Width / 2)),
                                      (this.Height - 75));

       this.Controls.Add(btnOK);  // Add button to form

       // Event handlers 
       btnOK.Click += new System.EventHandler(this.btnOK_Click);
       txtNbr.TextChanged += new System.EventHandler(this.txtChanged_Event);
   }

   protected void btnOK_Click( object sender, System.EventArgs e)
   {
      Application.Exit();
   }

   protected void txtChanged_Event( object sender, System.EventArgs e)
   {
      try 
      {
         int iNbr = Convert.ToInt32(txtNbr.Text);
         
         if ( iNbr < 0 )
         {
            lblResponse.Text = "Number is less than zero";
         }
         else if (iNbr > 1000)
         {
            lblResponse.Text = "Number is greater than 1000";
         }
         else
         {
            lblResponse.Text = String.Format("Number is {0}", txtNbr.Text);
         }
      }
  
      catch(ArgumentException)
      {
          lblResponse.Text = "No number.";
      }
      catch(FormatException)
      {
          lblResponse.Text = "Not a number.";
      }
      catch(OverflowException)
      {
          lblResponse.Text = "Number too big or too small.";
      }
   }

   public static void Main( string[] args )
   {
      Application.Run( new frmGetNumber() );
   }
}
