// text1.cs - Working with text controls
//--------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

public class frmGetName : Form
{
   private Button btnOK;

   private Label  lblFirst;
   private Label  lblMiddle;
   private Label  lblLast;
   private Label  lblFullName;
   private Label  lblInstructions;

   private TextBox txtFirst;
   private TextBox txtMiddle;
   private TextBox txtLast;

   public frmGetName()
   {
      InitializeComponent();
   }    

   private void InitializeComponent()
   {
       this.FormBorderStyle = FormBorderStyle.Fixed3D;
       this.Text = "Get User Name";
       this.StartPosition = FormStartPosition.CenterScreen;

       // Instantiate the controls...
       lblInstructions = new Label();
       lblFirst    = new Label();
       lblMiddle   = new Label();
       lblLast     = new Label();
       lblFullName = new Label();

       txtFirst    = new TextBox();
       txtMiddle   = new TextBox();
       txtLast     = new TextBox();

       btnOK = new Button();   

       // Set properties

       lblFirst.AutoSize = true;
       lblFirst.Text     = "First Name:";
       lblFirst.Location = new Point( 20, 20);

       lblMiddle.AutoSize = true;
       lblMiddle.Text     = "Middle Name:";
       lblMiddle.Location = new Point( 20, 50);

       lblLast.AutoSize = true;
       lblLast.Text     = "Last Name:";
       lblLast.Location = new Point( 20, 80);
     
       lblFullName.AutoSize = true;
       lblFullName.Location = new Point( 20, 110 );  
      
       txtFirst.Width = 100;
       txtFirst.Location = new Point(140, 20);

       txtMiddle.Width = 100;
       txtMiddle.Location = new Point(140, 50);

       txtLast.Width = 100;
       txtLast.Location = new Point(140, 80);

       lblInstructions.Width = 250;
       lblInstructions.Height = 60;
       lblInstructions.Text = "Enter your first, middle, and last name." + 
                              "\nYou will see your name appear as you type." +
                              "\nFor fun, edit your name after entering it.";
       lblInstructions.TextAlign = ContentAlignment.MiddleCenter;
       lblInstructions.Location = 
           new Point(((this.Width/2) - (lblInstructions.Width / 2 )), 140);

       this.Controls.Add(lblFirst);    // Add label to form
       this.Controls.Add(lblMiddle);   
       this.Controls.Add(lblLast);     
       this.Controls.Add(lblFullName); 
       this.Controls.Add(txtFirst);
       this.Controls.Add(txtMiddle);
       this.Controls.Add(txtLast);
       this.Controls.Add(lblInstructions);

       btnOK.Text = "Done";
       btnOK.BackColor = Color.LightGray;
       btnOK.Location = new Point(((this.Width/2) - (btnOK.Width / 2)),
                                      (this.Height - 75));

       this.Controls.Add(btnOK);  // Add button to form

       // Event handlers 
       btnOK.Click += new System.EventHandler(this.btnOK_Click);
       txtFirst.TextChanged += new System.EventHandler(this.txtChanged_Event);
       txtMiddle.TextChanged += new System.EventHandler(this.txtChanged_Event);
       txtLast.TextChanged += new System.EventHandler(this.txtChanged_Event);
   }

   protected void btnOK_Click( object sender, System.EventArgs e)
   {
      Application.Exit();
   }

   protected void txtChanged_Event( object sender, System.EventArgs e)
   {
      lblFullName.Text = txtFirst.Text + " " + txtMiddle.Text + " " + txtLast.Text;
   }

   public static void Main( string[] args )
   {
      Application.Run( new frmGetName() );
   }
}
