// ex1703.cs - using the color dialogs
//--------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

public class ColorForm : Form
{
   private MainMenu myMainMenu;


   public ColorForm()
   {
      InitializeComponent();
   }    

   private void InitializeComponent()
   {
      this.Text = "Exercise - Colors!";
      this.StartPosition = FormStartPosition.CenterScreen;
      this.FormBorderStyle = FormBorderStyle.Sizable;
      this.Width = 400;

      myMainMenu = new MainMenu();

      MenuItem menuitemFile = myMainMenu.MenuItems.Add("&File");
      menuitemFile.MenuItems.Add(new MenuItem("Color",
                         new EventHandler(this.Color_Selection)));

      menuitemFile.MenuItems.Add(new MenuItem("Exit",
                         new EventHandler(this.Exit_Selection)));
      this.Menu = myMainMenu;
   }

   protected void Exit_Selection( object sender, System.EventArgs e )
   {                                 
      Application.Exit();
   }

   protected void Color_Selection( object sender, System.EventArgs e )
   {
      ColorDialog myColorDialog = new ColorDialog();

      if ( myColorDialog.ShowDialog() != DialogResult.Cancel )
      {
         this.BackColor = myColorDialog.Color;
      }
   }

   public static void Main( string[] args )
   {
      Application.Run( new ColorForm() );
   }
}
