using System;
using System.Windows.Forms;
using System.Drawing;

public class frmApp : Form
{
   private Label myDateLabel;
   private MainMenu myMainMenu;

   public frmApp()
   {
       this.Text = "STY Menus";
       this.FormBorderStyle = FormBorderStyle.Fixed3D;

       myDateLabel = new Label();      // Create label

       DateTime currDate = new DateTime();
       currDate = DateTime.Now;
       myDateLabel.Text = currDate.ToString();
       myDateLabel.AutoSize = true;
       myDateLabel.Location = new Point( 50, 70);
       myDateLabel.BackColor = this.BackColor;
       this.Controls.Add(myDateLabel);  // Add label to form
       this.Width = (myDateLabel.PreferredWidth + 100);

       CreateMyMenu();
   }

   protected void MenuUpdate_Selection( object sender, System.EventArgs e)
   {
       DateTime currDate;
       currDate = DateTime.Now;
       this.myDateLabel.Text = currDate.ToString();
   }

   protected void FileExit_Selection( object sender, System.EventArgs e)
   {
      this.Close();
   }

   public void CreateMyMenu() 
   {
      myMainMenu = new MainMenu();
      
      MenuItem menuitemFile = myMainMenu.MenuItems.Add("&File");
      menuitemFile.MenuItems.Add(new MenuItem("Update &Date", 
                                 new EventHandler(this.MenuUpdate_Selection),
                                 Shortcut.CtrlH));
      menuitemFile.MenuItems.Add(new MenuItem("E&xit",
                                 new EventHandler(this.FileExit_Selection),
                                 Shortcut.CtrlX));
      this.Menu = myMainMenu;
   }

   public static void Main( string[] args )
   {
      Application.Run( new frmApp() );
   }
}
