// menu3b.cs - menus
//--------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

public class frmApp : Form
{
   private Label myDateLabel;
   private MainMenu myMainMenu;

   private MenuItem menuItemFile;
     private MenuItem menuItemUD;
     private MenuItem menuItemActive;

   private MenuItem menuItemHelp;
     private MenuItem menuItemExit;
     private MenuItem menuItemAbout;

   public frmApp()
   {
      InitializeComponent();
   }    

   private void InitializeComponent()
   {
       this.Text = "STY Menus";
       this.StartPosition = FormStartPosition.CenterScreen;

       myDateLabel = new Label();      // Create label

       DateTime currDate = new DateTime();
       currDate = DateTime.Now;
       myDateLabel.Text = currDate.ToString();

       myDateLabel.AutoSize = true;
       myDateLabel.Location = new Point( 50, 70);
       myDateLabel.BackColor = this.BackColor;

       this.Controls.Add(myDateLabel);  // Add label to form

       // Set width of form based on Label's width
       this.Width = (myDateLabel.PreferredWidth + 100);

       CreateMyMenu();
   }

   private void UpdateTime()
   {
      if( menuItemActive.Checked == true)
      {
         DateTime currDate = new DateTime();
         currDate = DateTime.Now;
         this.myDateLabel.Text = currDate.ToString();
      }
      else
      {
         this.myDateLabel.Text = "** " + this.myDateLabel.Text + " **";
      }
   }

   protected void Menu_Selection( object sender, System.EventArgs e)
   {

      if (sender == menuItemExit)
      {
          Application.Exit();
      }
      else
      if (sender == menuItemAbout)
      {
          // display an about form
      }
      else
      if ( sender == menuItemActive )
      {
         MenuItem tmp = new MenuItem();
         tmp = (MenuItem) sender;

         if ( tmp.Checked == true )
            tmp.Checked = false;
         else
            tmp.Checked = true;
      }
      else
      if ( sender == menuItemUD )
      {
         UpdateTime();
      }                
   }

   public void CreateMyMenu() 
   {
      myMainMenu = new MainMenu();

      // Define File menu...
      menuItemFile = myMainMenu.MenuItems.Add("&File");

      // Define Update Date sub menu option...
      menuItemUD      = new MenuItem();
      menuItemUD.Text = "Update &Date";
      menuItemUD.Shortcut = Shortcut.CtrlD;
      menuItemUD.Click += new EventHandler(this.Menu_Selection);
      menuItemUD.Index = 0;

      // Define Exit sub menu option...
      menuItemExit = new MenuItem();
      menuItemExit.Click += new EventHandler(this.Menu_Selection);
      menuItemExit.Text  = "E&xit";
      menuItemExit.Shortcut = Shortcut.CtrlX;
      menuItemExit.ShowShortcut = false;
      menuItemExit.Index = 1;

      // Add items to File menu...
      menuItemFile.MenuItems.AddRange( new MenuItem[]
                          {menuItemUD, menuItemExit});

      // Define About menu...
      menuItemHelp = myMainMenu.MenuItems.Add("&Help");

      // Define Active sub menu item...
      menuItemActive         = new MenuItem();
      menuItemActive.Text    = "Active";
      menuItemActive.Checked = true;
      menuItemActive.Click  += new EventHandler(this.Menu_Selection);
      menuItemActive.Index   = 0;
                                     
      // Define About sub Menu
      menuItemAbout = new MenuItem();
      menuItemAbout.Text  = "&About";
      menuItemAbout.Click += new EventHandler(this.Menu_Selection);
      menuItemAbout.ShowShortcut = false;
      menuItemAbout.Shortcut = Shortcut.CtrlA;
      menuItemAbout.Index = 1;

      // Add items to Help menu...
      menuItemHelp.MenuItems.AddRange( new MenuItem[]
                         {menuItemActive, menuItemAbout});

      this.Menu = myMainMenu;
   }

   public static void Main( string[] args )
   {
      Application.Run( new frmApp() );
   }
}
