// myform.cs - displaying sub-forms
//--------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

public class frmApp : Form
{
   private MainMenu myMainMenu;

   public frmApp()
   {
      InitializeComponent();
   }    

   private void InitializeComponent()
   {
      this.Text = "Canned Dialogs";
      this.StartPosition = FormStartPosition.CenterScreen;
      this.FormBorderStyle = FormBorderStyle.Sizable;
      this.Width = 400;

      myMainMenu = new MainMenu();
      
      MenuItem menuitemFile = myMainMenu.MenuItems.Add("&File");
      menuitemFile.MenuItems.Add(new MenuItem("My Form", 
                                 new EventHandler(this.Menu_Selection)));
      menuitemFile.MenuItems.Add(new MenuItem("My Other Form", 
                                 new EventHandler(this.Menu_Selection)));
      menuitemFile.MenuItems.Add("-");
      menuitemFile.MenuItems.Add(new MenuItem("Exit",
                                 new EventHandler(this.Menu_Selection)));
      this.Menu = myMainMenu;
   }

   protected void Menu_Selection( object sender, System.EventArgs e )
   {                                 
      switch (((MenuItem) sender).Text )
      {
        case "Exit":
             Application.Exit();
             break;

        case "My Form":
             subForm aForm = new subForm();
             aForm.Text = "A Show form";
             aForm.Show();
             break;

        case "My Other Form":
             subForm bForm = new subForm();
             bForm.Text = "A ShowDialog form";
             bForm.ShowDialog();
             break;

        default:
             MessageBox.Show("DEFAULT", "PopUp");
             break;
      }
   }

   public static void Main( string[] args )
   {
      Application.Run( new frmApp() );
   }
}


public class subForm : Form
{
   private MainMenu mySubMainMenu;

   public subForm()
   {
      InitializeComponent();
   }    

   private void InitializeComponent()
   {
      this.Text = "My sub-form";
      this.StartPosition = FormStartPosition.CenterScreen;
      this.FormBorderStyle = FormBorderStyle.FixedDialog;
      this.Width = 300;
      this.Height = 250;

      mySubMainMenu = new MainMenu();
      
      MenuItem menuitemFile = mySubMainMenu.MenuItems.Add("&File");
      menuitemFile.MenuItems.Add(new MenuItem("Close",
                             new EventHandler(this.CloseMenu_Selection)));
      this.Menu = mySubMainMenu;
   }

   protected void CloseMenu_Selection( object sender, System.EventArgs e )
   {                                 
      this.Close();
   }
}

