// attrUsedCircle.cs - using the CodeStatus attribute 
//----------------------------------------------------
using System;

[CodeStatus("Beta")]
public class Circle
{
    public int x;
    public int y;
    public double radius;
    private const float PI = 3.14159F;
    
    [CodeStatus("Final", Coder="Brad", Tester="Joe")]
    public double Area()  // Uses values from data members
    {
       return Area(radius);
    }

    [CodeStatus("Beta", Coder="Brad")]
    public double Area( double rad )
    {
       double theArea;
       theArea = PI * rad * rad;
       Console.WriteLine("  The area for radius ({0}) is {1}", rad, theArea);
       return theArea;
    }

    [CodeStatus("Coding")]
    public double Area(int x1, int y1, double rad)
    {
        return Area(rad);
    }

    [CodeStatus("Tested", Tester="Fred")]
    public double Area( int x1, int y1, int x2, int y2 )
    {
       int x_diff;
       int y_diff;
       double rad;

       x_diff = x2 - x1;
       y_diff = y2 - y1;

       rad = (double) Math.Sqrt((x_diff * x_diff) + (y_diff * y_diff));

       return Area(rad);
    }

    [CodeStatus("Beta")]
    public Circle()
    {
       x = 0;
       y = 0;
       radius = 0.0;
    }
}
